"use strict"
// базовый общий для всех
XHEBaseObject = require("../../xhe_base.js")

/////////////////////////////////////////// Plgn_ProxyChecker ////////////////////////////////////////
class XHEPROXYCHECKER extends XHEBaseObject
{
///////////////////////////////// SERVICE FUNCTIONS ////////////////////////////////////////////////
    // server initialization
    constructor(server, password = "") {
	    super(server, password, "Plgn_ProxyChecker")
    }
/////////////////////////////////////////////////////////////////////////////////////////////////////

    // Добавление прокси из файла в список
    add_proxies_from_file(path) {
        const params = ["path", path]
        return this.call_get("add_proxies_from_file", params)
    }

    // Разобрать строку с прокси и добавить найденные прокси в список
    add_proxies(str_proxy) {
        const params = ["str_proxy", str_proxy]
        return this.call_get("add_proxies", params)
    }

    // Добавить прокси из url
    add_proxies_from_url(url) {
        const params = ["url", url]
        return this.call_get("add_proxies_from_url", params)
    }

    // Очистить список прокси
    clear_proxy() {
        const params = []
        return this.call_get("clear_proxy", params)
    }

    // Сохранить список прокси
    save_proxy(path, param_proxy="all") {
        const params = ["path", path, "param_proxy", param_proxy]
        return this.call_get("save_proxy", params)
    }

    // Получить количество прокси в списке
    get_count_proxy(param_proxy="all") {
        const params = ["param_proxy", param_proxy]
        return this.call_get("get_count_proxy", params)
    }

    // Получить прокси по номеру
    get_proxy(n, param_proxy="all") {
        const params = ["n", n, "param_proxy", param_proxy]
        return this.call_get("get_proxy", params)
    }

    // Получить самый быстрый прокси в списке
    get_fastest_proxy(param_proxy="all") {
        const params = ["param_proxy", param_proxy]
        return this.call_get("get_fastest_proxy", params)
    }

    // Запустить проверку списка прокси
    run() {
        const params = []
        return this.call_get("run", params)
    }

    // Остановить проверку списка прокси
    stop() {
        const params = []
        return this.call_get("stop", params)
    }

    // Задать качество тестирования прокси (число проходов по списку прокси или другими словами сколько раз будет протестированно каждое прокси из списка)
    set_quality_testing(quality) {
        const params = ["quality", quality]
        return this.call_get("set_quality_testing", params)
    }

    // Задать юзер агент
    set_user_agent_string(user_agent) {
        const params = ["user_agent", user_agent]
        return this.call_get("set_user_agent_string", params)
    }

    // Задать время ожидания в миллисекундах при подключении к прокси
    set_proxy_timeout(timeout) {
        const params = ["timeout", timeout]
        return this.call_get("set_proxy_timeout", params)
    }

    // Задать время ожидания сервера
    set_server_timeout(timeout) {
        const params = ["timeout", timeout]
        return this.call_get("set_server_timeout", params)
    }

    // Проверка прокси в черном списке
    proxy_in_blacklist(ip) {
        const params = ["ip", ip]
        return this.call_get("proxy_in_blacklist", params)
    }

    // Прокси подходит под фильтр для порта
    is_valid_by_port_filter(ip, port_filter, mode) {
        const params = ["ip", ip, "port_filter", port_filter, "mode", mode]
        return this.call_get("is_valid_by_port_filter", params)
    }

    // Проверка на анонимность прокси
    proxy_is_anonymous(ip) {
        const params = ["ip", ip]
        return this.call_get("proxy_is_anonymous", params)
    }

    // Задать путь к файлу куда сохранять хорошие прокси
    set_path_for_good_proxy(path) {
        const params = ["path", path]
        return this.call_get("set_path_for_good_proxy", params)
    }

    // Задает сохранять ли хорошие прокси в заданный фаил в настроиках
    set_save_good_proxy_to_file(save) {
        const params = ["save", save]
        return this.call_get("set_save_good_proxy_to_file", params)
    }

    // Получить качество тестирования прокси (число проходов по списку прокси или другими словами сколько раз будет протестированно каждое прокси из списка)
    get_quality_testing() {
        const params = []
        return this.call_get("get_quality_testing", params)
    }

    // Получить юзер агент
    get_user_agent_string() {
        const params = []
        return this.call_get("get_user_agent_string", params)
    }

    // Получить время ожидания в миллисекундах при подключении к прокси
    get_proxy_timeout() {
        const params = []
        return this.call_get("get_proxy_timeout", params)
    }

    // Получить время ожидания сервера
    get_server_timeout() {
        const params = []
        return this.call_get("get_server_timeout", params)
    }

    // Получить путь к файлу куда сохранять хорошие прокси
    get_path_for_good_proxy() {
        const params = []
        return this.call_get("get_path_for_good_proxy", params)
    }

    // Узнать сохраняются ли хорошие прокси в заданный в настройках фаил
    get_save_good_proxy_to_file() {
        const params = []
        return this.call_get("get_save_good_proxy_to_file", params)
    }
}
module.exports = XHEPROXYCHECKER
