<?php
/////////////////////////////////////////// Plgn_ProxyChecker //////////////////////////////////////
class XHEPROXYCHECKER extends XHEBaseObject
{
//////////////////////////// SERVICE FUNCTIONS /////////////////////////////////////////////////////
    // server initialization
    private string $inner_number;

    function __construct(string $server, string $password="")
	{
		$this->server = $server;
		$this->password = $password;
		$this->prefix = "Plgn_ProxyChecker";
	}
/////////////////////////////////////////////////////////////////////////////////////////////////////    
    
    // Добавление прокси из файла в список
    function add_proxies_from_file(string $path): int
    {
        $params = array( "path" => $path );
        return $this->call_get(__FUNCTION__, $params);
    }

    // Разобрать строку с прокси и добавить найденные прокси в список
    function add_proxies(string $str_proxy): int
    {
        $params = array( "str_proxy" => $str_proxy );
        return $this->call_get(__FUNCTION__, $params);
    }

    // Добавить прокси из url
    function add_proxies_from_url(string $url): int
    {
        $params = array( "url" => $url );
        return $this->call_get(__FUNCTION__, $params);
    }

    // Очистить список прокси
    function clear_proxy(): bool
    {
        $params = array(  );
        return $this->call_get(__FUNCTION__, $params);
    }

    // Сохранить список прокси
    function save_proxy(string $path, string $param_proxy="all"): bool
    {
        $params = array( "path" => $path, "param_proxy" => $param_proxy );
        return $this->call_get(__FUNCTION__, $params);
    }

    // Получить количество прокси в списке
    function get_count_proxy(string $param_proxy="all"): int
    {
        $params = array( "param_proxy" => $param_proxy );
        return $this->call_get(__FUNCTION__, $params);
    }

    // Получить прокси по номеру
    function get_proxy(string $n, string $param_proxy="all"): string
    {
        $params = array( "n" => $n, "param_proxy" => $param_proxy );
        return $this->call_get(__FUNCTION__, $params);
    }

    // Получить самый быстрый прокси в списке
    function get_fastest_proxy(string $param_proxy="all"): string
    {
        $params = array( "param_proxy" => $param_proxy );
        return $this->call_get(__FUNCTION__, $params);
    }

    // Запустить проверку списка прокси
    function run(): bool
    {
        $params = array(  );
        return $this->call_get(__FUNCTION__, $params);
    }

    // Остановить проверку списка прокси
    function stop(): bool
    {
        $params = array(  );
        return $this->call_get(__FUNCTION__, $params);
    }

    // Задать качество тестирования прокси (число проходов по списку прокси или другими словами сколько раз будет протестированно каждое прокси из списка)
    function set_quality_testing(string $quality): bool
    {
        $params = array( "quality" => $quality );
        return $this->call_get(__FUNCTION__, $params);
    }

    // Задать юзер агент
    function set_user_agent_string(string $user_agent): bool
    {
        $params = array( "user_agent" => $user_agent );
        return $this->call_get(__FUNCTION__, $params);
    }

    // Задать время ожидания в миллисекундах при подключении к прокси
    function set_proxy_timeout(string $timeout): bool
    {
        $params = array( "timeout" => $timeout );
        return $this->call_get(__FUNCTION__, $params);
    }

    // Задать время ожидания сервера
    function set_server_timeout(string $timeout): bool
    {
        $params = array( "timeout" => $timeout );
        return $this->call_get(__FUNCTION__, $params);
    }

    // Проверка прокси в черном списке
    function proxy_in_blacklist(string $ip): bool
    {
        $params = array( "ip" => $ip );
        return $this->call_get(__FUNCTION__, $params);
    }

    // Прокси подходит под фильтр для порта
    function is_valid_by_port_filter(string $ip, string $port_filter, string $mode): bool
    {
        $params = array( "ip" => $ip, "port_filter" => $port_filter, "mode" => $mode );
        return $this->call_get(__FUNCTION__, $params);
    }

    // Проверка на анонимность прокси
    function proxy_is_anonymous(string $ip): bool
    {
        $params = array( "ip" => $ip );
        return $this->call_get(__FUNCTION__, $params);
    }

    // Задать путь к файлу куда сохранять хорошие прокси
    function set_path_for_good_proxy(string $path): bool
    {
        $params = array( "path" => $path );
        return $this->call_get(__FUNCTION__, $params);
    }

    // Задает сохранять ли хорошие прокси в заданный фаил в настроиках
    function set_save_good_proxy_to_file(string $save): bool
    {
        $params = array( "save" => $save );
        return $this->call_get(__FUNCTION__, $params);
    }

    // Получить качество тестирования прокси (число проходов по списку прокси или другими словами сколько раз будет протестированно каждое прокси из списка)
    function get_quality_testing(): int
    {
        $params = array(  );
        return $this->call_get(__FUNCTION__, $params);
    }

    // Получить юзер агент
    function get_user_agent_string(): string
    {
        $params = array(  );
        return $this->call_get(__FUNCTION__, $params);
    }

    // Получить время ожидания в миллисекундах при подключении к прокси
    function get_proxy_timeout(): int
    {
        $params = array(  );
        return $this->call_get(__FUNCTION__, $params);
    }

    // Получить время ожидания сервера
    function get_server_timeout(): int
    {
        $params = array(  );
        return $this->call_get(__FUNCTION__, $params);
    }

    // Получить путь к файлу куда сохранять хорошие прокси
    function get_path_for_good_proxy(): string
    {
        $params = array(  );
        return $this->call_get(__FUNCTION__, $params);
    }

    // Узнать сохраняются ли хорошие прокси в заданный в настройках фаил
    function get_save_good_proxy_to_file(): bool
    {
        $params = array(  );
        return $this->call_get(__FUNCTION__, $params);
    }
};

?>
