from Objects.xhe_base import *


# Plgn_ProxyChecker
class XHEPROXYCHECKER(XHEBaseObject):
    # server initialization
    def __init__(self, server: str, password: str=""):
        self.server = server
        self.password = password
        self.prefix = "Plgn_ProxyChecker"


    # Добавление прокси из файла в список
    def add_proxies_from_file(self, path: str) -> int:
        params = {"path": path}
        return self.call_get("add_proxies_from_file", params)


    # Разобрать строку с прокси и добавить найденные прокси в список
    def add_proxies(self, str_proxy: str) -> int:
        params = {"str_proxy": str_proxy}
        return self.call_get("add_proxies", params)


    # Добавить прокси из url
    def add_proxies_from_url(self, url: str) -> int:
        params = {"url": url}
        return self.call_get("add_proxies_from_url", params)


    # Очистить список прокси
    def clear_proxy(self) -> bool:
        params = {}
        return self.call_get("clear_proxy", params)


    # Сохранить список прокси
    def save_proxy(self, path: str, param_proxy: str="all") -> bool:
        params = {"path": path, "param_proxy": param_proxy}
        return self.call_get("save_proxy", params)


    # Получить количество прокси в списке
    def get_count_proxy(self, param_proxy: str="all") -> int:
        params = {"param_proxy": param_proxy}
        return self.call_get("get_count_proxy", params)


    # Получить прокси по номеру
    def get_proxy(self, n: str, param_proxy: str="all") -> str:
        params = {"n": n, "param_proxy": param_proxy}
        return self.call_get("get_proxy", params)


    # Получить самый быстрый прокси в списке
    def get_fastest_proxy(self, param_proxy: str="all") -> str:
        params = {"param_proxy": param_proxy}
        return self.call_get("get_fastest_proxy", params)


    # Запустить проверку списка прокси
    def run(self) -> bool:
        params = {}
        return self.call_get("run", params)


    # Остановить проверку списка прокси
    def stop(self) -> bool:
        params = {}
        return self.call_get("stop", params)


    # Задать качество тестирования прокси (число проходов по списку прокси или другими словами сколько раз будет протестированно каждое прокси из списка)
    def set_quality_testing(self, quality: str) -> bool:
        params = {"quality": quality}
        return self.call_get("set_quality_testing", params)


    # Задать юзер агент
    def set_user_agent_string(self, user_agent: str) -> bool:
        params = {"user_agent": user_agent}
        return self.call_get("set_user_agent_string", params)


    # Задать время ожидания в миллисекундах при подключении к прокси
    def set_proxy_timeout(self, timeout: str) -> bool:
        params = {"timeout": timeout}
        return self.call_get("set_proxy_timeout", params)


    # Задать время ожидания сервера
    def set_server_timeout(self, timeout: str) -> bool:
        params = {"timeout": timeout}
        return self.call_get("set_server_timeout", params)


    # Проверка прокси в черном списке
    def proxy_in_blacklist(self, ip: str) -> bool:
        params = {"ip": ip}
        return self.call_get("proxy_in_blacklist", params)


    # Прокси подходит под фильтр для порта
    def is_valid_by_port_filter(self, ip: str, port_filter: str, mode: str) -> bool:
        params = {"ip": ip, "port_filter": port_filter, "mode": mode}
        return self.call_get("is_valid_by_port_filter", params)


    # Проверка на анонимность прокси
    def proxy_is_anonymous(self, ip: str) -> bool:
        params = {"ip": ip}
        return self.call_get("proxy_is_anonymous", params)


    # Задать путь к файлу куда сохранять хорошие прокси
    def set_path_for_good_proxy(self, path: str) -> bool:
        params = {"path": path}
        return self.call_get("set_path_for_good_proxy", params)


    # Задает сохранять ли хорошие прокси в заданный фаил в настроиках
    def set_save_good_proxy_to_file(self, save: str) -> bool:
        params = {"save": save}
        return self.call_get("set_save_good_proxy_to_file", params)


    # Получить качество тестирования прокси (число проходов по списку прокси или другими словами сколько раз будет протестированно каждое прокси из списка)
    def get_quality_testing(self) -> int:
        params = {}
        return self.call_get("get_quality_testing", params)


    # Получить юзер агент
    def get_user_agent_string(self) -> str:
        params = {}
        return self.call_get("get_user_agent_string", params)


    # Получить время ожидания в миллисекундах при подключении к прокси
    def get_proxy_timeout(self) -> int:
        params = {}
        return self.call_get("get_proxy_timeout", params)


    # Получить время ожидания сервера
    def get_server_timeout(self) -> int:
        params = {}
        return self.call_get("get_server_timeout", params)


    # Получить путь к файлу куда сохранять хорошие прокси
    def get_path_for_good_proxy(self) -> str:
        params = {}
        return self.call_get("get_path_for_good_proxy", params)


    # Узнать сохраняются ли хорошие прокси в заданный в настройках фаил
    def get_save_good_proxy_to_file(self) -> bool:
        params = {}
        return self.call_get("get_save_good_proxy_to_file", params)

